;##############################################
;##                 6                  ##
;##             " "               ##
;##                    ##
;##############################################

;-------------------------  

.include "tn2313def.inc"	;   
.list					;  

.def	temp = r16		;    
.def 	rab = r17		;   

.equ	kdel = 780

;-------------------------   

.cseg 					;    
.org 	0				;     

;--------------------------  
	
		ldi		temp, 0x7F	;     
		out		SPL, temp	;     

;--------------------------   

		ldi		temp, 0x80  ;   $80   temp
		out		CLKPR, temp	;    CLKPR
		ldi		temp, 0		;  0   temp
		out		CLKPR, temp	;     CLKPR

;--------------------------   
	
		out		DDRD, temp	;     DDRD ( PD  )

		ldi		temp, 0xFF	;   $FF   temp
		out		DDRB, temp	;     DDRB ( PB  )
		out		PORTB, temp	;      PORTB ( )
		out		PORTD, temp	;     PORTD (..)	


;--------------------------   T1

		ldi		temp, 0x05
		out		TCCR1B, temp
	
;---------------------------  

		ldi 	temp, 0x80		;  
		out		ACSR, temp

;-------------------------    

main:	in		temp, PIND	;    PD
		sbrs	temp, 0		;   		
		rjmp	m3			;   ,    
		
;-------------------------  

m1:		ldi		rab, 0b10000000	;   
m2:		ldi		temp, 0xFF
		eor		temp, rab
		out		PORTB, temp		;      PB
		rcall	wait1			; 
		lsr		rab				;    
		brcc 	m2				;       
		rjmp	main			;  

;-------------------------  

m3:		ldi		rab, 0b00000001	;   
m4:		ldi		temp, 0xFF
		eor		temp, rab
		out		PORTB, temp		;      PB
		rcall	wait1			; 
		lsl		rab				;    
		brcc	m4				;       
		rjmp	main			;  


;---------------------------------  

wait1:	push	temp			;    temp

		ldi		temp, 0			;  temp 
		out		TCNT1H, temp	;       	
		out		TCNT1L, temp	;       

wt1:	in		temp, TCNT1L	;     
		cpi		temp, low(kdel)	;     
		brlo	wt1				; ,  temp  low(kd)
wt2:	in		temp, TCNT1H	;     
		cpi		temp, high(kdel);     
		brlo	wt1				; ,  temp  high(kd)

		pop		temp			;    temp
		ret						;   
