;##############################################
;##                 8                  ##
;##      " "      ##
;##                                          ##
;##############################################

;-------------------------  

.include "tn2313def.inc"	;   
.list					;  

.def	temp = r16		;    
.def	count = r17		;  -


;-------------------------   

		.cseg 			;    
		.org	0		;     

start:	rjmp	init	;    
		reti			;   0
		reti			;   1
		reti			;     T1
		reti			;    T1
		reti			;    T1
		reti			;    T0
		reti			;  UART  
		reti			;  UART   
		reti			;  UART  
		reti			;   
		reti			;      
		reti			; / 1.  B 
		reti			; / 0.  B 
		reti			; / 0.  A 
		reti			; USI  
		reti			; USI 
		reti			; EEPROM 
		reti			;   


; -------------------  
init:

;--------------------------  
	
		ldi		temp, RAMEND	;     
		out		SPL, temp		;     

;--------------------------   /
	
		ldi 	temp, 0x08		;   PB
		out		DDRB, temp

		ldi		temp, 0x00
		out		DDRD, temp		;   PD
		out		PORTB, temp		;    PB

		ldi 	temp, 0x7F
		out		PORTD, temp		;   

;---------------------------  () 

		ldi 	temp, 0x80
		out		ACSR, temp


;---------------------------   T1

		ldi 	temp, 0x09		;   CTC
		out		TCCR1B, temp
m1:		ldi 	temp, 0x00		;  
		out		TCCR1A, temp


;--------------------------   
main:
		clr 	count		;    
		in		temp, PIND	;   D		
m2:		lsr 	temp		;   
		brcc 	m3			;      0
		inc		count		;   
		cpi		count, 7	;  (7 -  )
		brne	m2			;   , 
		rjmp	m1			;      

m3:		lsl		count				;     2
		mov		YL, count			;   
		ldi		YH, 0				;     
		ldi		ZL, low(tabkd*2)	;   -   tabkd
		ldi		ZH, high(tabkd*2)
		add		ZL, YL				;   16-. 
		adc		ZH, YH

		lpm		YL, Z+			;    . 
		lpm		YH, Z			;    . 
		out		OCR1AH, YH		;  .  .
		out		OCR1AL, YL		;  .  .

		ldi		temp, 0x40		;  
		out		TCCR1A, temp
		rjmp	main




; ###########################################################
; ##                            ##
; ###########################################################

tabkd:	.dw		4748,4480,4228,3992,3768,3556,3356







