
;##############################################
;##                 5                  ##
;##             " "               ##
;##############################################

;-------------------------  

.include "2313def.inc"	;   
.list					;  

;-------------------------   

.cseg 				;    
.org	0			;     

.def	temp = r16		;    
.def	loop1 = r17		;    
.def	loop2 = r18		;    
.def	loop3 = r19		;    
.def 	rab = r20		;   

;--------------------------  
	
		ldi		temp, 0x7F	;     
		out		SPL, temp	;     

;--------------------------   
	
		ldi		temp, 0		;   0   temp
		out		DDRD, temp	;     DDRD ( PD  )

		ldi		temp, 0xFF	;   $FF   temp
		out		DDRB, temp	;     DDRB ( PB  )
		out		PORTB, temp	;      PORTB ( )
		out		PORTD, temp	;     PORTD (..)	

;---------------------------  

		ldi 	temp, 0x80		;  
		out		ACSR, temp

;-------------------------    

main:	in		temp, PORTD	;    PD
		sbrs	temp, 0		;   		
		rjmp	m3			;   ,    
		
;-------------------------  

m1:		ldi		rab, 0b10000000	;   
m2:		ldi		temp, 0xFF
		eor		temp, rab
		out		PORTB, temp		;      PB
		rcall	wait1			; 
		lsr		rab				;    
		brcc 	m2				;       
		rjmp	main			;  

;-------------------------  

m3:		ldi		rab, 0b00000001	;   
m4:		ldi		temp, 0xFF
		eor		temp, rab
		out		PORTB, temp		;      PB
		rcall	wait1			; 
		lsl		rab				;    
		brcc	m4				;       
		rjmp	main			;  


;---------------------------------  

wait1:	push	loop1		;    loop1
		push	loop2		;    loop2
		push	loop3		;    loop3

		ldi		loop1, 15	;   loop1  
wt1:	dec		loop1		;    loop
		breq	wt4
		ldi		loop2, 100	;   loop2  
wt2:	dec		loop2		;    loop2
		breq	wt1
		ldi		loop3, 255	;   loop3  
wt3:	dec		loop3		;    loop3
		brne	wt3			;   ,  
		rjmp	wt2

wt4:	pop		loop3		;    loop3
		pop		loop2		;    loop2
		pop		loop1		;    loop1
		ret					;   




